package com.mortals.xhx.module.matter.web;

import com.mortals.xhx.base.system.param.service.ParamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonPhpController;
import com.mortals.xhx.module.matter.model.MatterEntity;
import com.mortals.xhx.module.matter.model.MatterQuery;
import com.mortals.xhx.module.matter.service.MatterService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
 *
 * 基础事项
 *
 * @author zxfei
 * @date 2022-01-20
 */
@RestController
@RequestMapping("matter")
public class MatterController extends BaseCRUDJsonPhpController<MatterService,MatterForm,MatterEntity,Long> {

    @Autowired
    private ParamService paramService;

    public MatterController(){
        super.setFormClass(MatterForm.class);
        super.setModuleDesc( "基础事项");
    }

    @Override
    protected void init(HttpServletRequest request, HttpServletResponse response, MatterForm form, Map<String, Object> model, Context context) {
        this.addDict(model, "appoveObjectShow", paramService.getParamBySecondOrganize("Matter","appoveObjectShow"));
        this.addDict(model, "operatScopeShow", paramService.getParamBySecondOrganize("Matter","operatScopeShow"));
        this.addDict(model, "appoveTimeLimitShow", paramService.getParamBySecondOrganize("Matter","appoveTimeLimitShow"));
        this.addDict(model, "handleType", paramService.getParamBySecondOrganize("Matter","handleType"));
        this.addDict(model, "isChargesShow", paramService.getParamBySecondOrganize("Matter","isChargesShow"));
        this.addDict(model, "certificationLevelsShow", paramService.getParamBySecondOrganize("Matter","certificationLevelsShow"));
        this.addDict(model, "windowToTheSceneNum", paramService.getParamBySecondOrganize("Matter","windowToTheSceneNum"));
        this.addDict(model, "isOnlineSubscribeShow", paramService.getParamBySecondOrganize("Matter","isOnlineSubscribeShow"));
        this.addDict(model, "isExpressTakeShow", paramService.getParamBySecondOrganize("Matter","isExpressTakeShow"));
        this.addDict(model, "isProvinceAcquisitionShow", paramService.getParamBySecondOrganize("Matter","isProvinceAcquisitionShow"));
        this.addDict(model, "isApplyProvinceShow", paramService.getParamBySecondOrganize("Matter","isApplyProvinceShow"));
        this.addDict(model, "onlineType", paramService.getParamBySecondOrganize("Matter","onlineType"));
        this.addDict(model, "onlineToTheSceneNum", paramService.getParamBySecondOrganize("Matter","onlineToTheSceneNum"));
        this.addDict(model, "onlineOperatDeep", paramService.getParamBySecondOrganize("Matter","onlineOperatDeep"));
        this.addDict(model, "isExpressTakeOnlineShow", paramService.getParamBySecondOrganize("Matter","isExpressTakeOnlineShow"));
        this.addDict(model, "isDoorTakeShow", paramService.getParamBySecondOrganize("Matter","isDoorTakeShow"));
        this.addDict(model, "eventTypeShow", paramService.getParamBySecondOrganize("Matter","eventTypeShow"));
        this.addDict(model, "performHierarchyShow", paramService.getParamBySecondOrganize("Matter","performHierarchyShow"));
        this.addDict(model, "powerSourceShow", paramService.getParamBySecondOrganize("Matter","powerSourceShow"));
        this.addDict(model, "performDeptTypeShow", paramService.getParamBySecondOrganize("Matter","performDeptTypeShow"));
        this.addDict(model, "goveServiceCenterShow", paramService.getParamBySecondOrganize("Matter","goveServiceCenterShow"));
        this.addDict(model, "isConvenientCenterShow", paramService.getParamBySecondOrganize("Matter","isConvenientCenterShow"));
        this.addDict(model, "terminalHandle", paramService.getParamBySecondOrganize("Matter","terminalHandle"));
        this.addDict(model, "isOnline", paramService.getParamBySecondOrganize("Matter","isOnline"));
        this.addDict(model, "isOnlinePayShow", paramService.getParamBySecondOrganize("Matter","isOnlinePayShow"));
        this.addDict(model, "entrustmentDepartmen", paramService.getParamBySecondOrganize("Matter","entrustmentDepartmen"));
        this.addDict(model, "matterStatus", paramService.getParamBySecondOrganize("Matter","matterStatus"));
        this.addDict(model, "type", paramService.getParamBySecondOrganize("Matter","type"));
        this.addDict(model, "mattertype", paramService.getParamBySecondOrganize("Matter","mattertype"));
        this.addDict(model, "eventType", paramService.getParamBySecondOrganize("Matter","eventType"));
        this.addDict(model, "parson", paramService.getParamBySecondOrganize("Matter","parson"));
        this.addDict(model, "lengal", paramService.getParamBySecondOrganize("Matter","lengal"));
        this.addDict(model, "source", paramService.getParamBySecondOrganize("Matter","source"));
        super.init(request, response, form, model, context);
    }


    /**
     * 添加事项到站点
     */
    @PostMapping(value = "addMatterToSite")
    public String addBusinessToSite(@RequestBody Map<String, Object> map) {
        JSONObject jsonObject = new JSONObject();
        Map<String, Object> model = new HashMap<String, Object>();
        String matterIds=(String)map.get("matterIds");
        Long siteId=(Long)map.get("siteId");

        try {
            this.service.addMatterToSite(matterIds,siteId,getContext());
            jsonObject.put(KEY_RESULT_DATA, model);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_SUCCESS);
        } catch (Exception e) {
            log.error("获取异常", e);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            jsonObject.put(KEY_RESULT_MSG, super.convertException(e));
        }
        return jsonObject.toJSONString();
    }

    /**
     * 查询基础事项
     */
    @PostMapping(value = "list")
    public String list(@RequestBody MatterQuery query) {
        try {
            MatterForm form = new MatterForm();
            form.setQuery(query);
            return super.list(form);
        } catch (Exception e) {
            log.error("查询基础事项列表错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 新增基础事项
     */
    @PostMapping(value = "add")
    public String add() {
        try {
            MatterForm form = new MatterForm();
            return super.add(form);
        } catch (Exception e) {
            log.error("新增基础事项错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 编辑基础事项
     */
    @GetMapping(value = "edit")
    public String edit(Long id) {
        try {
            MatterForm form = new MatterForm();
            form.setId(new Long[]{id});
            return super.edit(form);
        } catch (Exception e) {
            log.error("基础事项模块错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 保存基础事项
     */
    @PostMapping(value = "save")
    public String save(@RequestBody MatterEntity entity) {
        try {
            MatterForm form = new MatterForm();
            form.setMatter(entity);
            return super.save(form);
        } catch (Exception e) {
            log.error("基础事项模块错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 删除基础事项
     */
    @GetMapping(value = "delete")
    public String delete(String id) {
        try {
            MatterForm form = new MatterForm();
            String[] split = id.split(",");
            Long[] ids = Arrays.asList(split).stream().map(Long::parseLong).toArray(Long[]::new);
            form.setId(ids);
            return super.delete(form);
        } catch (Exception e) {
            log.error("删除基础事项错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 查看基础事项
     */
    @GetMapping(value = "info")
    public String info(Long id) {
        try {
            MatterForm form = new MatterForm();
            form.setId(new Long[]{id});
            return super.view(form);
        } catch (Exception e) {
            log.error("查看基础事项错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }


    /**
     * 基础事项导入模板下载
     */
    @PostMapping(value = "downloadTemplate")
    public void downloadTemplate() {
        try {
            super.downloadTemplate();
        } catch (Exception e) {
            log.error("基础事项导入模板下载错误", e);
        }
    }

    /**
     * 基础事项导出
     */
    @PostMapping(value = "importData")
    public String importData(MultipartFile file, boolean updateSupport) {
        try {
            return super.importData(file, updateSupport);
        } catch (Exception e) {
            log.error("基础事项导入错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
     * 基础事项导出
     */
    @PostMapping("exportExcel")
    public void exportExcel(@RequestBody MatterQuery query) {
        try {
            MatterForm form = new MatterForm();
            form.setQuery(query);
            super.exportExcel(form);
        } catch (Exception e) {
            log.error("基础事项导出错误", e);
        }
    }
}